require("src.entities")
require("src.constants")


function love.load()
  love.window.setMode(SCREEN_WIDTH, SCREEN_HEIGHT)
  local icon = love.image.newImageData("assets/ganesha.jpg")
  love.window.setIcon(icon)

  love.window.setTitle("Gajah Lompat | " .. TITLE_LIST[math.ceil(love.math.random() * #TITLE_LIST)])
end

local player = Player

player.position.x = (SCREEN_WIDTH - player.dimension.width) / 2
player.position.y = SCREEN_HEIGHT - 150

-- local currentPlatform = 0
local platformTable = {}

for i = 1, MAX_PLATFORMS, 1 do
  local platform = Platform
  platform.position.x = math.ceil(love.math.random(0, SCREEN_WIDTH - platform.dimension.width))
  platform.position.y = (#platformTable + 1) * math.ceil(love.math.random(40, 120))
  table.insert(platformTable, platform)
end

function love.draw()
  local background = love.graphics.newImage("assets/bg.png")

  for i = 0, love.graphics.getWidth() / background:getWidth() do
    for j = 0, love.graphics.getHeight() / background:getHeight() do
      love.graphics.draw(background, i * background:getWidth(), j * background:getHeight())
    end
  end

  -- love.graphics.draw(love.graphics.newImage("assets/wood.png"), 100, 100, 0, 1/10)
  for k, platform in pairs(platformTable) do
    platform.draw(platform, platform.position.x, platform.position.y)
  end

  player.draw(player, player.position.x, player.position.y, 0, player.flip)
end

function love.update(dt)
  local dx = 0
  local dy = 0

  if player.position.y + player.dimension.height > SCREEN_HEIGHT then
    player.yVel = BOUNCE
    dy = dy + player.yVel
  else
    player.yVel = player.yVel + GRAVITY
    dy = dy + player.yVel
  end

  if love.keyboard.isDown("left") and love.keyboard.isDown("right") then
    dx = dx
  elseif love.keyboard.isDown("left") and player.position.x > 0 then
    player.flip = false
    dx = dx - PLAYER_SPEED
  elseif love.keyboard.isDown("right") and player.position.x < SCREEN_WIDTH - player.dimension.width then
    player.flip = true
    dx = dx + PLAYER_SPEED
  end

  player.position.x = player.position.x + dx
  player.position.y = player.position.y + dy
end
